---
schema_version: "1"
id: bb4b28adeae8a7ca8ce6c468517c20cccb1a33f5e66670d3006da24acf3b446d
title: Metadata Methods
collection: tableau
version: current
locale: en-us
portal_url: https://docs.salesforce.com/tableau/current/en-us/api/rest_api/REST/rest_api_ref_metadata.md
canonical_url: https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref_metadata.htm
source_site: help.tableau.com
content_type: documentation
content_hash: 85fe4047d6ef9fefeceff90ed963fc420319557ecd2722fa37ec4a27d7c7bdce
description: Metadata methods have been released incrementally beginning with Tableau version 2019
---
[Skip to main content](#main-content)

# Metadata Methods

Metadata methods have been released incrementally beginning with Tableau version 2019.3.

Using the metadata methods of the Tableau REST API, you can do the following tasks with Tableau metadata. Some methods require Data Management and are noted where this applies.

**Database**, including files (external asset type)

- Query a database or multiple databases
- Update (e.g., certify), move, or remove a database
- Add, query, or delete database permissions
- Add, query, or delete default database permissions

**Table** (external asset type)

- Query a table or multiple tables
- Update (e.g., certify), move, or remove a table
- Add, query, or delete table permissions

**Column** (external asset type)

- Query a column or multiple columns that belong to a specific table
- Update the column description or remove a column that belongs to a specific table

**Label** (a common interface for managing certifications, data quality warnings, sensitivity labels, and other data labels)

- Add, update, or delete labels
- Query labels on one or more assets
- Get, list, create, update, or delete label values
- List, create, update, or delete label categories

**Quality warning trigger** (enables monitoring of content and displays alerts when extract refresh and flow run failures occur)

- Add, update, delete quality warning trigger
- Query quality warning trigger

**Tag** (keywords that helps users find, filter, and categorize external assets and Tableau content)

- Add tags to a database, table, or column
- Delete a tag from a database, table, or column
- Batch add and delete tags on Tableau content and external assets

**Data quality warning (DQW)** (conveys data quality warning information about databases, tables, published data sources, and flows)  

- Add, update (e.g., severity), or delete a data quality warning
- Query data quality warnings
- Batch add, update, or delete data quality warnings to and from Tableau content and external assets

_**Note**: Both data quality warnings and certifications can be more generally managed through the newer **Label** methods. Tableau recommends using them instead._

**Data quality certification** (conveys data quality certification information for databases, tables, and data sources)  

- Add, update, or delete a data quality certification
- Query data quality certification

_**Note**: Both data quality certifications and warnings can be more generally managed through the newer **Label** methods. Tableau recommends using them instead._

The above functionality relates to metadata concepts and Data Catalog UI elements described at: [About Tableau Catalog](https://help.tableau.com/current/server/en-us/dm_catalog_overview.htm).

For deeper and more comprehensive API functionality for querying metadata and schema information for Tableau content, see [Tableau Metadata API](https://help.tableau.com/current/api/metadata_api/en-us/index.html) Help.

## Use Postman

Our Postman collection of requests enables you to construct, send, and examine HTTP requests to the Tableau Server or Tableau Cloud API without writing initial code. Postman is a free online app used by many developers for prototyping API calls, investigating issues, and generating request code in a variety of languages.

[Postman: Metadata](https://www.postman.com/salesforce-developers/salesforce-developers/folder/hiib1bv/metadata)

## Add Database Permissions

Add permissions to a database asset.

To add permissions, the database asset must be associated with a published data source.

**Version:** Available in API 3.5 (Tableau Cloud and Tableau Server) and later.  _[Version Overview](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm)_

**License:** Available with [Tableau Data Management](https://help.tableau.com/current/online/en-us/dm_overview.htm).

**Permissions:** Users that are granted ChangePermissions capabilities for the asset metadata and all administrators can add database permissions.  _[Permissions Overview](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_permissions.htm)_

**JWT Access Scope**: _Not available._      

#### URI

PUT api/_api-version_/sites/_site-luid_/databases/_database-luid_/permissions

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-luid</span></td><td>The LUID of the site asset.</td></tr><tr><td><span class="api-placeholder">database-luid</span></td><td>The LUID of the database asset.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <permissions>
    <database id="8d4aa9f-3d1a-4b49-8d6d-27f113cbd25e" />
    <granteeCapabilities>
      <user id="user-luid" />
      <capabilities>
        <capability name="ChangePermissions" mode="allow" />
        <!-- ...  additional capabilities ... -->
      </capabilities>
    </granteeCapabilities>
    <granteeCapabilities>
      <group id="group-luid" />
 	  <capabilities>
	    <capability name="Read" mode="Allow" />
	    <!-- ...  additional capabilities ... -->
	  </capabilities>
	</granteeCapabilities>
    <!-- ... additional grantee capability sets ...  -->
  </permissions>
</tsRequest>
```

#### Attribute Values

```
{
  "permissions": {
    "database": {
      "id": "1d4aa9f-3d1a-4b49-8d6d-27f113cbd25e"
    },
    "granteeCapabilities": [
      {
        "user": {
          "@id": "2d4aa9f-3d1a-4b49-8d6d-27f113cbd25e"
        },
        "capabilities": {
          "capability": {
            "name": "ChangePermissions",
            "mode": "allow"
          }
        }
      },
      {
        "group": {
          "id": "3d4aa9f-3d1a-4b49-8d6d-27f113cbd25e"
        },
        "capabilities": {
          "capability": {
            "name": "Read",
            "mode": "Allow"
          }
        }
      }
    ]
  }
}
```

#### Request Attributes

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><code>database</code>
                                </td>
                                <td>The LUID of the database asset you want to add permissions to.</td>
                            </tr>
                            <tr>
                                <td><code>user id</code>
                                </td>
                                <td>The LUID of the user to add permissions for.</td>
                            </tr>
                            <tr>
                                <td><code>capability name</code>
                                </td>
                                <td>
                                    <p>The capability to assign. If any capability has been granted or denied for a specified user or group, that capability is ignored. Valid capabilities for a database are:</p>
                                    <ul>
                                        <li><b>Read</b> (view)</li>
                                        <li><b>Write</b> (edit)</li>
                                        <li><b>ChangePermissions</b> (set permissions)</li>
                                        <li><b>ChangeHierarchy</b> (move)</li>
                                    </ul>
                                    <p>These values are case sensitive.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><code>capability mode</code>
                                </td>
                                <td>
                                    <p>Use one of the following capabilities:</p>
                                    <ul>
                                        <li><b>Allow</b>
                                        </li>
                                        <li><b>Deny</b>
                                        </li>
                                    </ul>
                                    <p>These values are case sensitive.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><code>group id</code>
                                </td>
                                <td>The LUID of the group to add permissions for.</td>
                            </tr>
                        </tbody>
                    </table>

#### Response Code

200

#### Response Body

```
<tsResponse>
  <permissions>
	<database id="e8d4aa9f-3d1a-4b49-8d6d-27f113cbd25e" name="oracle.test.tsi.lan:1521"/>
	<granteeCapabilities>
	  <user id="6265b714-7533-465d-b6db-6d0be92bfd07"/>
	  <capabilities>
		<capability name="Read" mode="Allow"/>
	  </capabilities>
	</granteeCapabilities>
  </permissions>
</tsResponse>
```

```
{
  "permissions": {
    "database": {
      "id": "e8d4aa9f-3d1a-4b49-8d6d-27f113cbd25e",
      "name": "oracle.test.tsi.lan:1521"
    },
    "granteeCapabilities": {
      "user": {
        " id": "6265b714-7533-465d-b6db-6d0be92bfd07"
      },
      "capabilities": {
        "capability": {
          "name": "Read",
          "mode": "Allow"
        }
      }
    }
  }
}
```

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400000</td><td>Bad request</td><td>The content of the request body is missing or incomplete, or contains malformed XML.</td></tr><tr><td>400</td><td>400120</td><td>Bad request</td><td>Permissions could not be added because support for explicit permissions is available for database assets associated with published data sources only.</td></tr><tr><td>401</td><td>401000</td><td>Unauthorized access</td><td>No authorization credentials were provided.</td></tr><tr><td>401</td><td>401002</td><td>Unauthorized access</td><td>Invalid authorization credentials were provided.</td></tr><tr><td>404</td><td>404000</td><td>Resource not found</td><td>The site LUID in the URI doesn't correspond to an existing site.</td></tr><tr><td>404</td><td>404031</td><td>Database not found</td><td>The requested database could not be found.</td></tr><tr><td>405</td><td>405000</td><td>Invalid request method</td><td>Request type was not <span class="uicontrol">PUT</span>.</td></tr><tr><td>409</td><td>409045</td><td>Database error</td><td>An unknown database asset error occurred.</td></tr><tr><td>409</td><td>409050</td><td>Database update error</td><td>An unknown error occurred and the database asset could not be updated.</td></tr><tr><td>409</td><td>409051</td><td>Database update forbidden</td><td>A user without "write"&nbsp;permissions to the database asset attempted an update.</td></tr></tbody></table>

## Add Default Database Permissions

Adds default permission capabilities to a user or group for table resources in that database.

Default permissions function as a permissions template for the database's table assets.

Note: If a database is in a project, default database permissions are not evaluated to determine table permissions. Use the [Add Default Permissions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_ref.htm#add_default_permissions) method to control default permission capabilities on tables through projects instead.

How default permissions are enforced depends on whether the database is locked or unlocked.

- **Locked to the database:** If the permissions on a database are locked or Locked to the database, existing child table assets and new child table assets that get indexed by Catalog will inherit the default permissions applied to the parent database asset. **Note:** If the database is locked, explicit permissions cannot be made for individual tables.
- **Managed by the owner:** If the permissions on a database are unlocked or **Managed by the owner**, only new child table assets that get indexed by Catalog will inherit the default permissions applied to the parent database asset. **Note:** If the database is unlocked, explicit permissions for the table can be made in a separate request.

This method is available if your Tableau Cloud site or Tableau Server is licensed with Data Management.

#### URI

PUT /api/_api-version_/sites/_site-luid_/databases/_database-luid_/default-permissions/tables

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-luid</span></td><td>The LUID of the site asset.</td></tr><tr><td><span class="api-placeholder">database-luid</span></td><td>The LUID of the database asset to set default permissions for.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <permissions>
    <granteeCapabilities>
      <user id="user-luid" />
      <capabilities>
        <capability name="capability-name" mode="capability-mode" />
        <!-- ... additional capabilities ... -->
      </capabilities>
    </granteeCapabilities>
    <granteeCapabilities>
      <group id="group-luid" />
      <capabilities>
        <capability name="capability-name" mode="capability-mode" />
        <!-- ...  additional capabilities ... -->
      </capabilities>
    </granteeCapabilities>
    <!-- ... additional grantee capability sets ... -->
  </permissions>
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table">
                            <colgroup>
                                <col class="api-parameters-table-col-1-extra-wide">
                                <col>
                            </colgroup>
                            <tbody>
                                <tr>
                                    <td><span class="api-placeholder">user-luid</span>
                                    </td>
                                    <td>The LUID of the user to add default permissions for.</td>
                                </tr>
                                <tr>
                                    <td><span class="api-placeholder">group-luid</span>
                                    </td>
                                    <td>The LUID of the group to add permissions for.</td>
                                </tr>
                                <tr>
                                    <td><span class="api-placeholder">capability-name</span>
                                    </td>
                                    <td>
                                        <p>                                     The capability to assign. If any capability has been granted or denied for a specified user or group, that capability is ignored. Valid capabilities for a databases are the following:                                    </p>
                                        <ul>
                                            <li><b>Read</b> (view)
                                </li>
                                            <li><b>Write</b> (edit)
                                </li>
                                            <li><b>ChangePermissions</b> (set permissions)</li>
                                            <li><b>ChangeHierarchy</b> (move)</li>
                                        </ul>
                                        <p>These values are case sensitive.</p>
                                    </td>
                                </tr>
                                <tr>
                                    <td><span class="api-placeholder">capability-mode</span>
                                    </td>
                                    <td>
                                        <p>Use one of the following capabilities: </p>
                                        <ul>
                                            <li><span class="api-command-ref">Allow</span>
                                            </li>
                                            <li><span class="api-command-ref">Deny</span>
                                            </li>
                                        </ul>
                                        <p>These values are case sensitive.</p>
                                    </td>
                                </tr>
                            </tbody>
                        </table>

#### Permissions

If Tableau Server or Tableau Cloud is licensed through Data Management, the following authorized users set default permissions for the database asset:

- Tableau Server admins or Tableau Cloud site admins
- Authorized users who have been granted explicit permission to set or "ChangePermissions" to the asset metadata

#### Response Code

200

#### Response Body

```
<tsResponse>
  <permissions>
	<database id="e8d4aa9f-3d1a-4b49-8d6d-27f113cbd25e" name="oracle.test.tsi.lan:1521"/>
	<granteeCapabilities>
	  <user id="6265b714-7533-465d-b6db-6d0be92bfd07"/>
	  <capabilities>
		<capability name="Read" mode="Allow"/>
	  </capabilities>
	</granteeCapabilities>
  </permissions>
</tsResponse>
```

#### Version

Version 3.5 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400000</td><td>Bad request</td><td>The content of the request body is missing or incomplete, or contains malformed XML.</td></tr><tr><td>403</td><td>403004</td><td>Permissions setting forbidden</td><td>A non-administrator user called this method but doesn't have permission to add permissions on the project.</td></tr><tr><td>403</td><td>403114</td><td>Permissions setting forbidden</td><td>Default permissions cannot be added because the database asset is locked.</td></tr><tr><td>404</td><td>404000</td><td>Site not found</td><td>The site LUID in the URI doesn't correspond to an existing site.</td></tr><tr><td>404</td><td>404003</td><td>Resource not found</td><td>The database LUID&nbsp;in the URI doesn't correspond to a database asset on the site.</td></tr><tr><td>404</td><td>404002</td><td>User not found</td><td>A user LUID in the request body as the grantee doesn't correspond to an existing user.</td></tr><tr><td>404</td><td>404012</td><td>Group not found</td><td>A group LUID in the request body doesn't correspond to an existing group.</td></tr><tr><td>404</td><td>404013</td><td>Capability not found</td><td>The capability in the request body doesn't correspond to a defined capability. This can apply to either an invalid capability name or to a capability other than <b>Allow</b> or <span class="api-command-ref">Deny</span> for any mode value.</td></tr><tr><td>405</td><td>405000</td><td>Invalid request method</td><td>Request type was not <span class="api-command-ref">PUT</span>.</td></tr></tbody></table>

## Add Data Quality Warning

Add a data quality warning to a database, table, column, published data source, flow, virtual connection, or virtual connection table.

**Note:** Data quality warnings and certifications can be more generally managed through the newer **Labels** methods. Tableau recommends using them to help ensure that you can manage your assets as new features are developed.

Try the [Update Labels](#update_labels_on_assets) method instead.

The Add Data Quality Warning method adds a data quality warning to an asset. (An automatically-generated monitoring warning does not count towards this limit.) In Tableau Cloud February 2024 and Tableau Server 2024.2 and earlier, adding a data quality warning to an asset that already has one causes an error.

This method is available if your Tableau Cloud site or Tableau Server is licensed with Data Management.

#### URI

POST api/_api-version_/sites/_site-id_/dataQualityWarnings/_content-type_/_content-luid_

#### Parameter Values

<table class="api-parameters-table">
                            <colgroup>
                                <col class="api-parameters-table-col-1-wide">
                                <col>
                            </colgroup>
                            <tbody>
                                <tr>
                                    <td><span class="api-placeholder">api-version</span>
                                    </td>
                                    <td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td>
                                </tr>
                                <tr>
                                    <td><span class="api-placeholder">site-id</span>
                                    </td>
                                    <td>The unique ID of the site asset.</td>
                                </tr>
                                <tr>
                                    <td><span class="api-placeholder">content-type</span>
                                    </td>
                                    <td>
                            The type of asset that the data quality warning is being attached to. To specify the  type, use:
                            <ul><li><span class="uicontrol">database</span></li><li><span class="uicontrol">table</span></li><li><span class="uicontrol">column</span> <i>- Available in API 3.16 and later (Tableau Cloud October 2022, Server 2022.3)</i></li><li><span class="uicontrol">datasource</span></li><li><span class="uicontrol">flow</span></li><li><span class="uicontrol">virtual connection</span></li><li><span class="uicontrol">virtual connection table</span></li></ul><p>These values are not case sensitive.</p></td>
                                </tr>
                                <tr>
                                    <td><span class="api-placeholder">content-luid</span>
                                    </td>
                                    <td>
                            The unique ID of the asset (database, table, column, published data source, flow, virtual connection, or virtual connection table). This is the same as the content ID.
                        </td>
                                </tr>
                            </tbody>
                        </table>

#### Request Body

```
<tsRequest>
  <dataQualityWarning type="type" isActive="state" message="message" isSevere="severity"/>
</tsRequest>
```

#### Attribute Values

Any combination of attributes inside the **<dataQualityWarning>** element is valid, but the data quality warning type is required. If the data quality warning type is not included, an error is thrown.

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide" style="width: 264px;">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">type</span>
                                </td>
                                <td>
                                    <p>Type of data quality warning to apply to the asset. To specify the type, use one of the following values:</p>
                                    <ul>
                                        <li><span class="uicontrol">DEPRECATED</span>
                                        </li>
                                        <li><span class="uicontrol">WARNING</span>
                                        </li>
                                        <li><span class="uicontrol">STALE</span>
                                        </li>
                                        <li><span class="uicontrol">SENSITIVE_DATA</span>
                                        </li>
                                        <li><span class="uicontrol">MAINTENANCE</span>
                                        </li>
                                    </ul>
                                    <p>These values are case sensitive.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">state</span>
                                </td>
                                <td>
                                    <p>(Optional) Controls whether the data quality warning displays. Value can be "<span class="uicontrol">true</span>" or "<span class="uicontrol">false</span>". If the state is not specified, the data quality warning is set to "true" and is visible by default.  For more information about data quality warnings, see "Set a Data Quality Warning" in the <a href="https://help.tableau.com/current/server/en-us/dm_dqw.htm">Server Help</a> or <a href="https://help.tableau.com/current/online/en-us/dm_dqw.htm">Cloud Help</a>.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">message</span>
                                </td>
                                <td>
                                    <p>(Optional. Was required in Tableau Server 2023.3 and earlier.)</p>
                                    <p>A custom message to accompany the data quality warning. You can format the message with italics, bold text, links, images, and more. Use HTML character entities to match the special characters in the <a href="https://help.tableau.com/current/api/rest_api/en-us/Img/formatting_guide.png" target="_blank">formatting guide</a> that's normally visible as a tooltip in the UI.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">severity</span>
                                </td>
                                <td>(Optional) Enables high visibility for the data quality warning when set to "<span class="uicontrol">true</span>". Value can be "<span class="uicontrol">true</span>" or "<span class="uicontrol">false</span>". For more information, see the "Visibility" section of the "Set a Data Quality Warning" topic in the <a href="https://help.tableau.com/current/server/en-us/dm_dqw.htm#high_visibility">Server Help</a> or <a href="https://help.tableau.com/current/online/en-us/dm_dqw.htm#high_visibility">Cloud Help</a>. </td>
                            </tr>
                        </tbody>
                    </table>

#### Permissions

If Tableau Server or Tableau Cloud is licensed through Data Management, the following users have permissions to add the data quality warning:

- Tableau Server admins or Tableau Cloud site admins
- Authorized users who have been granted explicit permission to edit or "Write" to the asset metadata

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:labels:update
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

201

#### Response Body

**Example response:**

```
<tsResponse>
   <dataQualityWarning id="1c8ebdfc-270a-4414-812c-3306a1c95e07" userDisplayName="Steve Nguyen"
	contentId="0d7465f2-4989-417e-b88d-f787359edc63" contentType="DATABASE" message="Delayed"
	type="WARNING" isActive="true" createdAt="2020-10-08T00:00:35Z" isSevere="false">
	<site id="a946d998-2ead-4894-bb50-1054a91dcab3"/>
	<owner id="cdfe8548-84c8-418e-9b33-2c0728b1234a"/>
   </dataQualityWarning>
</tsResponse>
```

#### Version

Version 3.5 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2" style="width: 87px;"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400000</td><td>Bad request</td><td>The content of the request body is missing or incomplete, or contains malformed XML.</td></tr><tr><td>400</td><td>400108</td><td>Generic add data quality warning error</td><td>The data quality warning could not be added for some other reason than those specified in this table.</td></tr><tr><td>400</td><td>400109</td><td>Bad request</td><td>The request body is missing the data quality warning type.</td></tr><tr><td>401</td><td>401000</td><td>Unauthorized access</td><td>No authorization credentials were provided.</td></tr><tr><td>401</td><td>401002</td><td>Unauthorized access</td><td>Invalid authorization credentials were provided.</td></tr><tr><td>403</td><td>403004</td><td>Unauthorized operation</td><td>Insufficient permissions to perform the operation.</td></tr><tr><td>404</td><td>404000</td><td>Resource not found</td><td>The site ID in the URI doesn't correspond to an existing site.</td></tr><tr><td>404</td><td>404029</td><td>Content not found</td><td>The requested asset could not be found.</td></tr><tr><td>409</td><td>409004</td><td>Invalid parameter</td><td>One or more values in the request body are invalid.</td></tr></tbody></table>

## Batch Add or Update Data Quality Warnings

Add or update multiple data quality warnings on assets.

**Note:** Data quality warnings and certifications can be more generally managed through the newer **Labels** methods. Tableau recommends using them to help ensure that you can manage your assets as new features are developed.

Try the [Update Labels](#update_labels_on_assets) method instead.

This method is available if your Tableau Cloud site or Tableau Server is licensed with Data Management.

#### URI

POST api/api-version/sites/site-id/dataQualityWarnings/createOrUpdate

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The unique ID of the site asset.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <contentList>
	<content contentType="content" id="database-id" />
	<content contentType="content" id="table-id" />
	<content contentType="content" id="column-id" />
	<content contentType="content" id="datasource-id" />
	<content contentType="content" id="flow-id" />
	<content contentType="content" id="virtualconnection-id" />
	<content contentType="content" id="virtualconnectiontable-id" />
  </contentList>
  <dataQualityWarning type="type" message="message" isActive="state" isSevere="severity" />
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide" style="width: 264px;">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">content</span>
                                </td>
                                <td>
                                    <p>The type of content or asset the data quality warning is attached to. To specify type, use one of the following values:</p>
                                    <ul>
                                        <li><span class="api-label">database</span>
                                        </li>
                                        <li><span class="api-label">table</span>
                                        </li>
                                        <li><span class="api-label">column</span> <i>- Available in API 3.16 and later (Tableau Cloud October 2022, Server 2022.3)</i></li>
                                        <li><span class="api-label">datasource</span>
                                        </li>
                                        <li><span class="api-label">flow</span>
                                        </li>
                                        <li><span class="api-label">virtualconnection</span>
                                        </li>
                                        <li><span class="api-label">virtualconnectiontable</span>
                                        </li>
                                    </ul>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">database-id</span>
                                </td>
                                <td>The unique ID of the database asset.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">table-id</span>
                                </td>
                                <td>The unique ID of the table asset.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">column-id</span>
                                </td>
                                <td>The unique ID of the column asset.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">datasource-id</span>
                                </td>
                                <td>The unique ID of the data source content.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">flow-id</span>
                                </td>
                                <td>The unique ID of the flow content.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">virtualconnection-id</span>
                                </td>
                                <td>The unique ID of the virtual connection.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">virtualconnectiontable-id</span>
                                </td>
                                <td>The unique ID of the virtual connection table.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">type</span>
                                </td>
                                <td>
                                    <p>The type of data quality warning to apply to the content or asset. To specify type, use one of the following values:</p>
                                    <ul>
                                        <li><span class="uicontrol">DEPRECATED</span>
                                        </li>
                                        <li><span class="uicontrol">WARNING</span>
                                        </li>
                                        <li><span class="uicontrol">STALE</span>
                                        </li>
                                        <li><span class="uicontrol">SENSITIVE_DATA</span>
                                        </li>
                                        <li><span class="uicontrol">MAINTENANCE</span>
                                        </li>
                                    </ul>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">message</span>
                                </td>
                                <td>(Optional) A custom message to accompany the data quality warning. You can format the message with italics, bold text, links, images, and more. Use HTML character entities to match the special characters in the <a href="https://help.tableau.com/current/api/rest_api/en-us/Img/formatting_guide.png" target="_blank">formatting guide</a> that's normally visible as a tooltip in the UI.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">state</span>
                                </td>
                                <td>(Optional) Controls whether the data quality warning displays. Value can be "<span class="uicontrol">true</span>" or "<span class="uicontrol">false</span>". If the state is not specified, the data quality warning is set to "true" and is visible by default.  For more information about data quality warnings, see "Set a Data Quality Warning" in the <a href="https://help.tableau.com/current/server/en-us/dm_dqw.htm">Server Help</a> or <a href="https://help.tableau.com/current/online/en-us/dm_dqw.htm">Cloud Help</a>.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">severity</span>
                                </td>
                                <td>(Optional) Enables high visibility for when the data quality warning is set to "<span class="uicontrol">true</span>". Value can be "<span class="uicontrol">true</span>" or "<span class="uicontrol">false</span>". For more information, see the "Visibility" section of the "Set a Data Quality Warning" topic in the <a href="https://help.tableau.com/current/server/en-us/dm_dqw.htm#high_visibility">Server Help</a> or <a href="https://help.tableau.com/current/online/en-us/dm_dqw.htm#high_visibility">Cloud Help</a>. </td>
                            </tr>
                        </tbody>
                    </table>

#### Permissions

If Tableau Server or Tableau Cloud is licensed through Data Management, the following users have permissions to batch add or update data quality warnings:

- Tableau Server admins or Tableau Cloud site admins
- Authorized users who have been granted explicit permission to edit or "Write" to the asset metadata

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:labels:update
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Response Body

**Example response**

```
<tsRequest>
  <dataQualityWarningList>
	<dataQualityWarning id="8f58aa47-7313-4504-8537-52d869552e18" userDisplayName="Mark Nguyen" contentId="7cfd2ac8-a934-4aa8-bf24-96bff08a019c" contentType="DATABASE" message="Contact admin with questions" type="WARNING" isActive="true" createdAt="2021-06-26T21:34:46Z" updatedAt="2021-06-26T21:34:46Z" isSevere="true">
	  <site id="1e4b3aa0-b48a-4b8e-9bdf-74b7596b9f0a" />
	  <owner id="adcc51d7-8558-4099-9f87-dc1a1615d297" />
	</dataQualityWarning>
	<dataQualityWarning id="c8f0b332-a1c1-48f1-b650-86f342ab937f" userDisplayName="Mark Nguyen" contentId="f6dcfd24-7c65-40f4-a3f3-c29f91b7731e" contentType="DATASOURCE" message="Contact admin with questions" type="WARNING" isActive="true" createdAt="2021-06-26T21:34:46Z" updatedAt="2021-06-26T21:34:46Z" isSevere="true">
	  <site id="1e4b3aa0-b48a-4b8e-9bdf-74b7596b9f0a" />
	  <owner id="adcc51d7-8558-4099-9f87-dc1a1615d297" />
	<dataQualityWarning>
  </dataQualityWarningList>
</tsRequest>
```

#### Version

Version 3.12 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2" style="width: 87px;"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400109</td><td>Bad request</td><td>The content of the request body (content type, content id, or dataQualityWarning attributes) is missing, incomplete, or contains malformed XML.</td></tr><tr><td>400</td><td>400108</td><td>Generic add data quality warning error</td><td>The data quality warning could not be added for some other reason than those specified in this table.</td></tr><tr><td>403</td><td>403004</td><td>Unauthorized operation</td><td>Insufficient permissions to perform the operation.</td></tr><tr><td>404</td><td>404029</td><td>Content not found</td><td>The content does not exist.</td></tr><tr><td>409</td><td>409004</td><td>Invalid parameter</td><td>One or more values in the request body are invalid.</td></tr></tbody></table>

## Batch Add or Update Data Quality Certifications

Create or update one or more data quality certifications for different content and asset items.

**Note:** Data quality warnings and certifications can be more generally managed through the newer **Labels** methods. Tableau recommends using them to help ensure that you can manage your assets as new features are developed.

Try the [Update Labels](#update_labels_on_assets) method instead.

A content or asset item can only have up to one data quality certification applied to it. Adding a data quality certification to an item that already has one will update the data quality certification with the latest specified values.

This method is available if your Tableau Cloud site or Tableau Server is licensed with Data Management.

#### URI

POST api/api-version/sites/site-id/dataQualityCertifications

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The unique ID of the site asset.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <contentList>
	<content contentType="content" id="database-id" />
	<content contentType="content" id="table-id" />
	<content contentType="content" id="datasource-id" />
	<content contentType="content" id="virtualconnection-id" />
	<content contentType="content" id="virtualconnectiontable-id" />
  </contentList>
  <dataQualityIndicator type="type" message="message"
	active="state" elevated="severity" />
</tsRequest>
```

#### Attribute Values

Any combination of attributes inside the **<dataQualityIndicator>** element is valid, however **type** and **message** attributes are required.

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide" style="width: 264px;">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">content</span>
                                </td>
                                <td>
                                    <p>The type of content or asset the data quality warning is attached to. To specify type, use one of the following values:</p>
                                    <ul>
                                        <li><span class="api-label">database</span>
                                        </li>
                                        <li><span class="api-label">table</span>
                                        </li>
                                        <li><span class="api-label">datasource</span>
                                        </li>
                                        <li><span class="api-label">virtualconnection</span>
                                        </li>
                                        <li><span class="api-label">virtualconnectiontable</span>
                                        </li>
                                    </ul>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">database-id</span>
                                </td>
                                <td>The unique ID of the database asset.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">table-id</span>
                                </td>
                                <td>The unique ID of the table asset.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">datasource-id</span>
                                </td>
                                <td>The unique ID of the data source content.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">virtualconnection-id</span>
                                </td>
                                <td>The unique ID of the virtual connection asset.
					</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">virtualconnectiontable-id</span>
                                </td>
                                <td>The unique ID of the virtual connection table asset.
					</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">type</span>
                                </td>
                                <td>
                                    <p>Use the following value to apply a data quality certification:&nbsp;<span class="uicontrol">CERTIFIED</span>.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">message</span>
                                </td>
                                <td>A custom message to accompany the data quality certification. You can format the message with italics, bold text, links, images, and more. Use HTML character entities to match the special characters in the <a href="https://help.tableau.com/current/api/rest_api/en-us/Img/formatting_guide.png" target="_blank">formatting guide</a> that's normally visible as a tooltip in the UI.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">state</span>
                                </td>
                                <td>(Optional) Controls whether the data quality certification displays. Value can be "<span class="uicontrol">true</span>" or "<span class="uicontrol">false</span>". If the state is not specified, the data quality certification is set to "true" and is visible by default. For more information about data quality certifications, see "Set a Data Quality Certification" in the <a href="https://help.tableau.com/current/server/en-us/datasource_certified.htm">Server Help</a> or <a href="https://help.tableau.com/current/online/en-us/datasource_certified.htm">Cloud Help</a>.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">severity</span>
                                </td>
                                <td>(Optional) Enables high visibility for when the data quality certification is set to "<span class="uicontrol">true</span>". Value can be "<span class="uicontrol">true</span>" or "<span class="uicontrol">false</span>". If the severity is not specified, the data quality certification is set to "false." This setting is available only through the REST API.</td>
                            </tr>
                        </tbody>
                    </table>

#### Permissions

If Tableau Server or Tableau Cloud is licensed through Data Management, the following users have permissions to add or update data quality certifications:

- Tableau Server admins or Tableau Cloud site admins
- Authorized users who have been granted explicit permission to edit or "Write" to the asset metadata

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:labels:update
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

201

#### Response Body

**Example response**

```
<tsRequest>
  <dataQualityIndicatorList>
	<dataQualityIndicator id="8f58aa47-7313-4504-8537-52d869552e18"
	    userDisplayName="Mark Nguyen" contentId="7cfd2ac8-a934-4aa8-bf24-96bff08a019c" contentType="DATABASE" message="Marketing approved" type="CERTIFIED" active="true" createdAt="2021-09-26T21:34:46Z" updatedAt="2021-09-26T21:34:46Z" elevated="true">
	  <site id="1e4b3aa0-b48a-4b8e-9bdf-74b7596b9f0a" />
	  <owner id="adcc51d7-8558-4099-9f87-dc1a1615d297" />
	</dataQualityIndicator>
	<dataQualityIndicator id="c8f0b332-a1c1-48f1-b650-86f342ab937f"
	    userDisplayName="Mark Nguyen" contentId="f6dcfd24-7c65-40f4-a3f3-c29f91b7731e" contentType="DATASOURCE" message="Marketing approved" type="CERTIFIED" active="true" createdAt="2021-09-26T21:34:46Z" updatedAt="2021-09-26T21:34:46Z" elevated="true">
	  <site id="1e4b3aa0-b48a-4b8e-9bdf-74b7596b9f0a" />
	  <owner id="adcc51d7-8558-4099-9f87-dc1a1615d297" />
	<dataQualityIndicator>
  </dataQualityIndicatorList>
</tsRequest>
```

#### Version

Version 3.13 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2" style="width: 87px;"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400108</td><td>Generic data quality certification error</td><td>The data quality certification could not be added for some reason other than those specified in this table.</td></tr><tr><td>403</td><td>403004</td><td>Unauthorized operation</td><td>Insufficient permissions to perform the operation.</td></tr><tr><td>404</td><td>404029</td><td>Content not found</td><td>The content does not exist.</td></tr><tr><td>409</td><td>409004</td><td>Invalid parameter</td><td>One or more values in the request body are invalid.</td></tr></tbody></table>

## Add or Update Monitoring Quality Warning on Content

Create or update one or more monitoring quality warnings.

You can monitor for extract refresh failures on extract data sources or flow run failures on flows. An asset can only have one instance of monitoring. Adding monitoring to an asset that already has it will update it to use the latest specified values.

**Note:** An asset can have one monitoring warning in addition to other [data quality warnings](#add_dqw).

This method is available if your Tableau Cloud site or Tableau Server is licensed with Data Management.

#### URI

**Add or update a monitoring quality warning for an asset**

POST api/_api-version_/sites/_site-id_/dataQualityTriggers/_content-type_/contentIds?filter=contentId:in:\[_content-luid_\]

**Add or update a monitoring quality warning for multiple assets**

POST api/_api-version_/sites/_site-id_/dataQualityTriggers/_content-type_/contentIds?filter=contentId:in:\[_content-luid1_,_content-luid2_,_content-luid3_,...\]

**Note:** The square brackets are required around the single LUID or comma-separated list of LUIDs.

#### Parameter Values

<table class="api-parameters-table">
                            <colgroup>
                                <col class="api-parameters-table-col-1-wide">
                                <col>
                            </colgroup>
                            <tbody>
                                <tr>
                                    <td><span class="api-placeholder">api-version</span>
                                    </td>
                                    <td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td>
                                </tr>
                                <tr>
                                    <td><span class="api-placeholder">site-id</span>
                                    </td>
                                    <td>The unique ID of the site asset.</td>
                                </tr>
                                <tr>
                                    <td><span class="api-placeholder">content-type</span>
                                    </td>
                                    <td>
                                        <p>
                            The type of content the monitoring is being applied to. Use one of the following values:
                            </p>
                                        <ul>
                                            <li><span class="uicontrol">datasource</span>
                                            </li>
                                            <li><span class="uicontrol">flow</span>
                                            </li>
                                        </ul>
                                        <p>These values are not case sensitive.</p>
                                    </td>
                                </tr>
                                <tr>
                                    <td><span class="api-placeholder">content-luid</span>
                                    </td>
                                    <td>
                                        <p>The LUID of the asset. This is the same as the content ID.</p>
                                        <p>The square brackets are required around the single LUID or comma-separated list of LUIDs.</p>
                                    </td>
                                </tr>
                            </tbody>
                        </table>

#### Request Body

```
<tsRequest>
  <dataQualityTrigger type="type" active="status" message="message" severe="severity"/>
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide" style="width: 264px;">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">type</span>
                                </td>
                                <td>
                                    <p>Type of monitoring quality warning. To specify the type, use one of the following values:</p>
                                    <ul>
                                        <li class="api-command-ref">EXTRACT_REFRESH</li>
                                        <li class="api-command-ref">FLOW_RUN</li>
                                    </ul>
                                    <p>These values are not case sensitive.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">status</span>
                                </td>
                                <td>
                                    <p>Monitoring status. Values can be "<span class="uicontrol">true</span>" or "<span class="uicontrol">false</span>". If set to "<span class="uicontrol">true</span>", the data source is monitored for extract refresh failures or the flow is monitored for flow run failures).</p>
                                    <p>If an extract refresh or flow run failure occurs, the specified data quality warning is attached  to the data source or flow (depending on <span class="api-parameters-table">type</span>). The data quality warning is removed when the extract refresh or flow run is successful.</p>
                                    <p>For more information about monitoring quality warnings, see the monitoring quality warning section of the "Set a Data Quality Warning" topic in the <a href="https://help.tableau.com/current/server/en-us/dm_dqw.htm#how-to-turn-on-a-monitoring-quality-warning">Server Help</a> or <a href="https://help.tableau.com/current/online/en-us/dm_dqw.htm#how-to-turn-on-a-monitoring-quality-warning">Cloud Help</a>.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">message</span>
                                </td>
                                <td>(Optional) A custom message for the data quality warning. You can format the message with italics, bold text, links, images, and more. Use HTML character entities to match the special characters in the <a href="https://help.tableau.com/current/api/rest_api/en-us/Img/formatting_guide.png" target="_blank">formatting guide</a> that's normally visible as a tooltip in the UI.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">severity</span>
                                </td>
                                <td>High visibility status of the data quality warning. Values can be "<span class="uicontrol">true</span>" or "<span class="uicontrol">false</span>". For more information, see the "Visibility" section of the "Set a Data Quality Warning" topic in the <a href="https://help.tableau.com/current/server/en-us/dm_dqw.htm#high_visibility">Server Help</a> or <a href="https://help.tableau.com/current/online/en-us/dm_dqw.htm#high_visibility">Cloud Help</a>.</td>
                            </tr>
                        </tbody>
                    </table>

#### Permissions

If Tableau Server or Tableau Cloud is licensed through Data Management, the following users have permissions to add a monitoring quality warning:

- Tableau Server admins or Tableau Cloud site admins
- Authorized users who have been granted explicit permission to edit or "Write" to the asset metadata

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:labels:update
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Response Body

**Example response**

```
<tsResponse>
  <dataQualityTriggerList>
	<dataQualityTrigger id="{trigger-luid}" siteId="{site-luid}"
		userId="{user-luid}" userDisplayName="Joe Nguyen" contentId="{content-luid}"
		contentType="DATASOURCE" message=" This message is specified by the user."
		type="EXTRACT_REFRESH" active="true" createdAt="Wed Sep 22 05:49:52 UTC 2020"
		updatedAt="Wed Sep 22 05:49:52 UTC 2020" severe="false"/>
  </dataQualityTriggerList>
</tsResponse>
```

#### Version

Version 3.11 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2" style="width: 87px;"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400136</td><td>Generic quality warning trigger error</td><td>The monitoring quality warning could not be added or updated for some other reason than those specified below.</td></tr><tr><td>403</td><td>403004</td><td>Unauthorized operation</td><td>Insufficient permissions to perform the operation.</td></tr><tr><td>409</td><td>409004</td><td>Invalid parameter</td><td>One or more values in the request body are invalid.</td></tr></tbody></table>

## Add Table Permissions

Add permissions to a table asset.

This method is available if your Tableau Cloud site or Tableau Server is licensed with Data Management.

#### URI

PUT api/_api-version_/sites/_site-luid_/tables/_table-luid_/permissions

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-luid</span></td><td>The LUID of the site asset.</td></tr><tr><td><span class="api-placeholder">table-luid</span></td><td>The LUID of the table asset.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <permissions>
    <table id="table-luid" />
    <granteeCapabilities>
      <user id="user-luid" />
      <capabilities>
        <capability name="capability-name" mode="capability-mode" />
        <!-- ... additional capabilities ... -->
      </capabilities>
    </granteeCapabilities>
    <granteeCapabilities>
      <group id="group-luid" />
      <capabilities>
        <capability name="capability-name" mode="capability-mode" />
        <!-- ... additional capabilities ... -->
      </capabilities>
    </granteeCapabilities>
    <!-- ... additional grantee capability sets ... -->
  </permissions>
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">table-luid</span>
                                </td>
                                <td>The LUID for the table asset you want to add permissions to.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">user-luid</span>
                                </td>
                                <td>The LUID of the user to add permissions for.</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">capability-name</span>
                                </td>
                                <td>
                                    <p>The capability to assign. If any capability has been granted or denied for a specified user or group, that capability is ignored. Valid capabilities for a database are:</p>
                                    <ul>
                                        <li><b>Read</b> (view)</li>
                                        <li><b>Write</b> (edit)</li>
                                        <li><b>ChangePermissions</b> (set permissions)</li>
                                        <li><b>ChangeHierarchy</b> (move)</li>
                                    </ul>
                                    <p>These values are case sensitive.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">capability-mode</span>
                                </td>
                                <td>
                                    <p>Use one of the following capabilities:</p>
                                    <ul>
                                        <li><b>Allow</b>
                                        </li>
                                        <li><b>Deny</b>
                                        </li>
                                    </ul>
                                    <p>These values are case sensitive.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">group-id</span>
                                </td>
                                <td>The LUID of the group to add permissions for.</td>
                            </tr>
                        </tbody>
                    </table>

#### Permissions

If Tableau Server or Tableau Cloud is licensed through Data Management, the following users have permissions to add table asset permissions:

- Tableau Server admins or Tableau Cloud site admins
- Authorized users who have been granted explicit permission to set or "ChangePermissions" to the asset metadata

#### Response Code

200

#### Response Body

**Example response:**

```
<tsResponse>
  <permissions>
	<table id="d0fe66ae-1407-4338-8520-9489d7ce959c" name="_WarehouseConfig"/>
	<granteeCapabilities>
	  <user id="6265b714-7533-465d-b6db-6d0be92bfd07"/>
	  <capabilities>
		<capability name="Read" mode="Allow"/>
	  </capabilities>
	</granteeCapabilities>
  </permissions>
</tsResponse>
```

#### Version

Version 3.5 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2" style="width: 87px;"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400000</td><td>Bad request</td><td>The content of the request body is missing or incomplete, or contains malformed XML.</td></tr><tr><td>400</td><td>400120</td><td>Bad request</td><td>Permissions could not be added because support for explicit permissions is available for table assets associated with published data sources only.</td></tr><tr><td>401</td><td>401000</td><td>Unauthorized access</td><td>No authorization credentials were provided.</td></tr><tr><td>401</td><td>401002</td><td>Unauthorized access</td><td>Invalid authorization credentials were provided.</td></tr><tr><td>403</td><td>403117</td><td>Database locked</td><td>Permissions for the table asset cannot be deleted because the database asset is locked.</td></tr><tr><td>404</td><td>404000</td><td>Resource not found</td><td>The site LUID in the URI doesn't correspond to an existing site.</td></tr><tr><td>404</td><td>404032</td><td>Table not found</td><td>The requested table asset could not be found.</td></tr><tr><td>409</td><td>409052</td><td>Table error</td><td>An unknown table asset error occurred.</td></tr><tr><td>409</td><td>409057</td><td>Table update error</td><td>An unknown error occurred and the table asset could not be updated.</td></tr><tr><td>409</td><td>409058</td><td>Table update forbidden</td><td>A user without "write"&nbsp;permissions to the table asset attempted an update.</td></tr></tbody></table>

## Add Tags to Column

Add one or more tags to a column.

For more information about tags, see [Tag Items](https://help.tableau.com/current/pro/desktop/en-us/tags.htm) in the Tableau User Help.

#### URI

PUT api/api-version/sites/site-id/columns/column-id/tags

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The unique ID of the site asset.</td></tr><tr><td><span class="api-placeholder">column-id</span></td><td>The unique ID of the column asset.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <tags>
	<tag label="tag-value1" />
	<tag label="tag-value2" />
  </tags>
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide" style="width: 264px;">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">tag-value1</span>
                                </td>
                                <td>
                                    <p>Keyword text you want to add to the asset.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">tag-value2</span>
                                </td>
                                <td>
                                    <p>Keyword text you want to add to the asset.</p>
                                </td>
                            </tr>
                        </tbody>
                    </table>

#### Permissions

If Tableau Server or Tableau Cloud is licensed through Data Management, the following users have permissions to add tags:

- Tableau Server admins or Tableau Cloud site admins
- Authorized users who have been granted explicit permission to edit or "Write" to the asset metadata

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:column_tags:update
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Response Body

**Example response**

```
<tsResponse>
  <tags>
	<tag label="Noteworthy" />
	<tag label="PII" />
  </tags>
</tsResponse>
```

#### Version

Version 3.9 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2" style="width: 87px;"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400000</td><td>Bad request</td><td>The content of the request body is missing or incomplete, or contains malformed XML.</td></tr><tr><td>403</td><td>403004</td><td>Unauthorized operation</td><td>Insufficient permissions to perform the operation.</td></tr><tr><td>409</td><td>409062</td><td>Generic column tag error</td><td>The tag or tags could not be added (or deleted) for some other reason than those specified above.</td></tr><tr><td>409</td><td>409066</td><td>Column not found</td><td>The column asset does not exist.</td></tr></tbody></table>

## Add Tags to Database

Add one or more tags to a database.

For more information about tags, see [Tag Items](https://help.tableau.com/current/pro/desktop/en-us/tags.htm) in the Tableau User Help.

#### URI

PUT api/api-version/sites/site-id/databases/database-id/tags

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The unique ID of the site asset.</td></tr><tr><td><span class="api-placeholder">database-id</span></td><td>The unique ID of the database asset.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <tags>
	<tag label="tag-value1" />
	<tag label="tag-value2" />
  </tags>
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide" style="width: 264px;">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">tag-value1</span>
                                </td>
                                <td>
                                    <p>Keyword text you want to add to the asset.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">tag-value2</span>
                                </td>
                                <td>Keyword text you want to add to the asset.</td>
                            </tr>
                        </tbody>
                    </table>

#### Permissions

If Tableau Server or Tableau Cloud is licensed through Data Management, the following users have permissions to add tags:

- Tableau Server admins or Tableau Cloud site admins
- Authorized users who have been granted explicit permission to edit or "Write" to the asset metadata

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:database_tags:update
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Response Body

**Example response**

```
<tsResponse>
  <tags>
	<tag label="Noteworthy" />
	<tag label="PII" />
  </tags>
</tsResponse>
```

#### Version

Version 3.9 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2" style="width: 87px;"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400000</td><td>Bad request</td><td>The content of the request body is missing or incomplete, or contains malformed XML.</td></tr><tr><td>403</td><td>403004</td><td>Unauthorized operation</td><td>Insufficient permissions to perform the operation.</td></tr><tr><td>404</td><td>404031</td><td>Database not found</td><td>The database asset does not exist.</td></tr><tr><td>409</td><td>409048</td><td>Generic database tag error</td><td>The tag or tags could not be added (or deleted) for some other reason than those specified above.</td></tr></tbody></table>

## Add Tags to Table

Add one or more tags to a table.

For more information about tags, see [Tag Items](https://help.tableau.com/current/pro/desktop/en-us/tags.htm) in the Tableau User Help.

#### URI

PUT api/api-version/sites/site-id/tables/table-id/tags

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The unique ID of the site asset.</td></tr><tr><td><span class="api-placeholder">table-id</span></td><td>The unique ID of the column asset.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <tags>
	<tag label="tag-value1" />
	<tag label="tag-value2" />
  </tags>
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide" style="width: 264px;">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">tag-value1</span>
                                </td>
                                <td>
                                    <p>Keyword text you want to add to the asset.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">tag-value2</span>
                                </td>
                                <td>
                                    <p>Keyword text you want to add to the asset.</p>
                                </td>
                            </tr>
                        </tbody>
                    </table>

#### Permissions

If Tableau Server or Tableau Cloud is licensed through Data Management, the following users have permissions to add tags:

- Tableau Server admins or Tableau Cloud site admins
- Authorized users who have been granted explicit permission to edit or "Write" to the asset metadata

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:table_tags:update
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Response Body

**Example response**

```
<tsResponse>
  <tags>
	<tag label="Noteworthy" />
	<tag label="PII" />
  </tags>
</tsResponse>
```

#### Version

Version 3.9 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2" style="width: 87px;"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400000</td><td>Bad request</td><td>The content of the request body is missing or incomplete, or contains malformed XML.</td></tr><tr><td>403</td><td>403004</td><td>Unauthorized operation</td><td>Insufficient permissions to perform the operation.</td></tr><tr><td>404</td><td>404032</td><td>Table not found</td><td>The table asset does not exist.</td></tr><tr><td>409</td><td>409055</td><td>Generic table tag error</td><td>The tag or tags could not be added (or deleted) for some other reason than those specified above.</td></tr></tbody></table>

## Batch Add Tags

Add multiple tags to items that are different content and asset types.

This method is available if your Tableau Cloud site or Tableau Server is licensed with Data Management.

For more information about tags, see [Tag Items](https://help.tableau.com/current/pro/desktop/en-us/tags.htm) in the Tableau User Help.

#### URI

PUT api/api-version/sites/site-id/tags:batchCreate

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The unique ID of the site asset.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <tagBatch>
	<tags>
	   <tag label="tag-value1"></tag>
	   <tag label="tag-value2"></tag>
	</tags>
	<contents>
	   <content id="database-id"></content>
	   <content id="table-id"></content>
	   <content id="column-id"></content>
	   <content id="datasource-id"></content>
	   <content id="workbook-id"></content>
	   <content id="flow-id"></content>
	</contents>
  </tagBatch>
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide" style="width: 264px;">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">tag-value1</span>
                                </td>
                                <td>
                                    <p>Keyword text you want to add to item.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">tag-value2</span>
                                </td>
                                <td>
                                    <p>Keyword text you want to add to item.</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">database-id</span>
                                </td>
                                <td>The unique ID of the database asset.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">table-id</span>
                                </td>
                                <td>The unique ID of the table asset.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">column-id</span>
                                </td>
                                <td>The unique ID of the column asset.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">datasource-id</span>
                                </td>
                                <td>The unique ID of the data source content.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">workbook-id</span>
                                </td>
                                <td>The unique ID of the workbook content.
</td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">flow-id</span>
                                </td>
                                <td>The unique ID of the flow content.
</td>
                            </tr>
                        </tbody>
                    </table>

#### Permissions

If Tableau Server or Tableau Cloud is licensed through Data Management, the following users have permissions to add tags:

- Tableau Server admins or Tableau Cloud site admins
- Authorized users who have been granted explicit permission to edit or "Write" to the asset metadata

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:tags:batch_create
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Response Body

**Example response**

```
<tsRequest>
  <tagBatch>
	<tags>
	   <tag label="PII"></tag>
	   <tag label="Noteworthy"></tag>
	</tags>
	<contents>
	   <content id="21cade8c-d4eb-4fef-bd4a-bdb9d8b09b7d" contentType="Database"></content>
	   <content id="a0314be1-afd4-4a4f-ab85-d75dac661c41" contentType="Table"></content>
	   <content id="8fec4046-e054-476d-a6d0-e808b0d5448b" contentType="Column"></content>
	   <content id="c8c3a0be-3ac8-4de7-8bd6-f912900a1ccd" contentType="Datasource"></content>
	   <content id="ec2b7845-d627-430e-b99c-8543ed50b25c" contentType="Workbook"></content>
	   <content id="c4a560eb-c8a6-48c6-86f4-c9d5e518d027" contentType="Flow"></content>
	</contents>
  </tagBatch>
</tsRequest>
```

#### Version

Version 3.9 and later. For more information, see [REST API and Resource Versions](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm).

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2" style="width: 87px;"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400000</td><td>Bad request</td><td>The content of the request body is missing or incomplete, or contains malformed XML.</td></tr><tr><td>403</td><td>403004</td><td>Unauthorized operation</td><td>Insufficient permissions to perform the operation.</td></tr><tr><td>404</td><td>404029</td><td>Content not found</td><td>The content does not exist.</td></tr><tr><td>404</td><td>404031</td><td>Database not found</td><td>The database asset does not exist.</td></tr><tr><td>404</td><td>404032</td><td>Table not found</td><td>The table asset does not exist.</td></tr><tr><td>409</td><td>409004</td><td>Invalid parameter</td><td>One or more values in the request body are invalid.</td></tr><tr><td>409</td><td>409066</td><td>Column not found</td><td>The column asset does not exist.</td></tr></tbody></table>

## Add Tags to Virtual Connection

Adds tags to a virtual connection.

**Version:** Available in API 3.23 (Tableau Cloud June 2024 / Tableau Server 2024.2) and later. _[Version Overview](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm)_

**License:** Requires [Tableau Data Management](https://help.tableau.com/current/online/en-us/dm_overview.htm).

**Permissions:** You must have the View permission for the virtual connection and your site role must be at least Explorer.   _[Permissions Overview](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_permissions.htm)_

**JWT Access Scope**: tableau:virtual\_connection\_tags:update

- Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).
- For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### URI

PUT /api/api-version/sites/site-id/virtualconnections/virtualconnection-id/tags

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-id</span></td><td>The LUID for the site.</td></tr><tr><td><span class="api-placeholder">virtualconnection-id</span></td><td>The LUID for the virtual connection.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <tags>
    <tag label="tag" />
    <!-- ...additional tag elements... -->
  </tags>
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1"> <col></colgroup><tbody><tr><td><span class="api-placeholder">tag</span></td><td>The text of the tag.</td></tr></tbody></table>

#### cURL Request Example

`curl --location --request PUT 'http://MY-SERVER/api/3.29/sites/9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d/virtualconnections/12ab34cd-56ef-78ab-90cd-12ef34ab56cd/tags' --header 'Content-Type: application/xml' --header 'X-Tableau-Auth: HvZMqFFfQQmOM4L-AZNIQA|5fI6T54OPK1Gn1p4w0RtHv6EkojWRTwq|a946d998-2ead-4894-bb50-1054a91dcab3' --data @data.xml`

**Contents of data.xml.**

```
<tsRequest>
  <tags>
    <tag label="Office" />
    <!-- ...additional tag elements... -->
  </tags>
</tsRequest>
```

#### Response Code

200

#### Response Body

```
<tsResponse>
  <tags>
    <tag label="tag"/>
    <!-- ...additional tags... -->
  </tags>
</tsResponse>
```

#### Errors

<table class="api-error-table"><colgroup><col class="api-error-table-col-1"> <col class="api-error-table-col-2"> <col class="api-error-table-col-3"> <col></colgroup><tbody><tr><th>HTTP status</th><th><code>error</code> Code</th><th>Condition</th><th>Details</th></tr><tr><td>400</td><td>400000</td><td>Bad request</td><td>The content of the request body is missing or incomplete, or contains malformed XML.</td></tr><tr><td>400</td><td>400049</td><td>Error adding tags</td><td>There was a problem adding tags to the specified virtual connection.</td></tr><tr><td>403</td><td>403004</td><td>Adding tags forbidden</td><td>The user doesn't have permissions to add tags to the virtual connection.</td></tr><tr><td>404</td><td>404000</td><td>Site not found</td><td>The site ID in the URI is not for an existing site.</td></tr><tr><td>404</td><td>404006</td><td>Virtual connection not found</td><td>The virtual connection ID in URI doesn't correspond to an existing virtual connection.</td></tr><tr><td>404</td><td>405000</td><td>Invalid request method</td><td>Request type was not <span class="api-command-ref">PUT</span>.</td></tr></tbody></table>

For more information, see [Handling Errors](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_errors.htm).

## Create Label Category

Creates a data label category.

Note that category is one property of a label value (labelValue), which is itself a property of a label on an asset. Other properties of a labelValue include name and description. These properties determine label behavior and options that users see in label dialogs. For more information on data label objects and properties, see the [Data Labels in the REST API](https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_data_labels.htm) topic.

A Data Management license is not required to create, update, or delete label categories, but one is required to create, update, delete, and see labels on assets.

#### URI

POST api/api-version/sites/site-luid/labelCategories

#### Parameter Values

<table class="api-parameters-table"><colgroup><col class="api-parameters-table-col-1-wide"> <col></colgroup><tbody><tr><td><span class="api-placeholder">api-version</span></td><td>The version of the API to use, such as <code><span class="mc-variable Variables.REST-API-Version variable">3.29</span></code>. For more information, see <a href="https://help.tableau.com/current/api/rest_api/en-us/REST/rest_api_concepts_versions.htm" class="xref">REST API and Resource Versions</a>.</td></tr><tr><td><span class="api-placeholder">site-luid</span></td><td>The unique LUID of the site asset.</td></tr></tbody></table>

#### Request Body

```
<tsRequest>
  <labelCategory name="label-category-name"
    description="label-category-description" />
</tsRequest>
```

#### Attribute Values

<table class="api-parameters-table">
                        <colgroup>
                            <col class="api-parameters-table-col-1-wide" style="width: 264px;">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <td><span class="api-placeholder">label-category-name</span>
                                </td>
                                <td>
                                    <p>The label category name.</p>
                                    <p>Required. Must be 1-128 characters long. (In Tableau Server 2023.3 and earlier, must be 1-24 characters long.)</p>
                                </td>
                            </tr>
                            <tr>
                                <td><span class="api-placeholder">label-category-description</span>
                                </td>
                                <td>
                                    <p>The label category description.</p>
                                    <p>Required. Must be 1-500 characters in length.</p>
                                </td>
                            </tr>
                        </tbody>
                    </table>

#### Permissions

- Only a site or server administrator can create, update, or delete label categories.

#### Access Scope

Scope added in API 3.27 (Tableau Cloud December 2025 / Server 2025.3).

```
tableau:label_categories:create
```

For more information, see [Access scopes for UATs](https://help.tableau.com/current/api/cloud-manager/en-us/docs/unified_access_tokens.html#scopes) (Cloud) and access scopes for connected apps: [Cloud](https://help.tableau.com/current/online/en-us/connected_apps_scopes.htm), [Server-Windows](https://help.tableau.com/current/server/en-us/connected_apps_scopes.htm), or [Server-Linux](https://help.tableau.com/current/server-linux/en-us/connected_apps_scopes.htm).

#### Response Code

200

#### Version

Introduced in Tableau Cloud October 2023 (API 3.21) / Server 2023.3 (API 3.21).

#### Response Body

```
<tsResponse>
  <labelCategory name="label-category-name"
    description="label-category-description"/>
</tsResponse>
```

#### Errors

<table class="api-error-table">
                        <colgroup>
                            <col class="api-error-table-col-1">
                            <col class="api-error-table-col-2">
                            <col class="api-error-table-col-3">
                            <col>
                        </colgroup>
                        <tbody>
                            <tr>
                                <th>HTTP status</th>
                                <th><code>error</code> Code</th>
                                <th>Condition</th>
                                <th>Details</th>
[...]
